unit playmain;

// examples to call the embedded file in the unit

interface

uses
  Windows, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    btnPicload: TButton;
    Image1: TImage;
    Button2: TButton;
    btnAppload: TButton;
    procedure Button1Click(Sender: TObject);
    procedure btnPicloadClick(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure btnApploadClick(Sender: TObject);
  private
    function thisWaveCheck(vfname: string): boolean;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

Uses MMSystem, dws_logo2, fourembeded;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  //if not PlaySound(@UtopiaWindowsstarten_wav, 0, SND_MEMORY + SND_SYNC) then
    ShowMessage('Fehler beim Abspielen des Sounds');
end;

//procedure BinToHex(Buffer, Text: PChar; BufSize: Integer);
//function HexToBin(Text, Buffer: PChar; BufSize: Integer): Integer;


procedure TForm1.btnPicloadClick(Sender: TObject);
var mybitmap: TBitmap;
    bitStream: TStream;
begin
  //mybitmap.LoadFromFile('dws_logo.bmp'); for the mortals
  mybitmap:= TBitmap.Create;
  bitStream:= TMemoryStream.Create;
  try
    bitStream.Writebuffer(dws_logo_bmp, sizeof(dws_logo_bmp));
    bitStream.Position:= 0;
    mybitmap.LoadFromStream(bitStream);
    if assigned(mybitmap) then begin
      image1.Picture.assign(mybitmap);
      image1.update;
    end;
  finally
    bitStream.Free;
    mybitmap.Free;
  end;
end;

procedure TForm1.Image1Click(Sender: TObject);
var mybitmap: TBitmap;
   bitStream: TStream;
begin
 //sleep(5000);
   with TImage.Create(NIL) do begin
      parent:= self;
      setbounds(60, 80, 280, 200);
     mybitmap:= TBitmap.Create;
     bitStream:= TMemoryStream.Create;
     try
       bitStream.Writebuffer(dws_logo_bmp, sizeof(dws_logo_bmp));
       bitStream.Position:= 0;
       mybitmap.LoadFromStream(bitStream);
       if assigned(mybitmap) then begin
         Picture.assign(mybitmap);
         update;
       end;
       sleep(3000);
     finally
       bitStream.Free;
       mybitmap.Free;
       free;
     end;
   end;
end;

//Put your files into your delphi project at design time and then just compile it to get all into one file.
//You can even store waves and play it without the need to create a file, play it from memory.

procedure TForm1.btnApploadClick(Sender: TObject);
var bitStream: TMemoryStream;
    myexe: pchar;
    databuffer: pointer;
    datahandle: THandle;
begin
  //mybitmap.LoadFromFile('dws_logo.bmp'); for the mortals
  bitStream:= TMemoryStream.Create;
  try
    bitStream.Writebuffer(viergewinnt_exe, sizeof(viergewinnt_exe));
    bitStream.Position:= 0;
    bitstream.LoadFromStream(bitstream);
    bitstream.SaveToFile('viergewinnt.exe');
    //WinExec(pchar('viergewinnt.exe'){ + ' ' + ParamStr},SW_NORMAL);
    case WinExec(PChar('viergewinnt.exe'), SW_SHOWDEFAULT) of
      0: ShowMessage('The system is out of memory or resources.');
      ERROR_BAD_FORMAT: ShowMessage('The .EXE file is invalid (non-Win32 .EXE or error in .EXE image).');
      ERROR_FILE_NOT_FOUND: ShowMessage('The specified file was not found.');
      ERROR_PATH_NOT_FOUND: ShowMessage('The specified path was not found.');
    end;
    //myexe:= pchar(@fourgewinnt_exe);
    //myexe:= pchar(myexe +'.exe');
    //WinExec(datapuffer{ + ' ' + ParamStr},SW_NORMAL);
    //reader.Read(DataSize, Sizeof(DataSize));
    //DataHandle:=GlobalAlloc(GHND,sizeof(gewinnt_exe));
    //DataBuffer:=GlobalLock(DataHandle);
    //WinExec(pchar(databuffer){ + ' ' + ParamStr},SW_NORMAL);
  finally
    bitStream.Free;
  end;

end;

function TForm1.thisWaveCheck(vfname: string): boolean;
var
  F : file;
  BuffHeader: array[1..12] of char;
begin
  AssignFile(F, vfname);
  FileMode:=0;
  Reset(F,1);
  try
    BlockRead(F, BuffHeader, 12);
    result:=(Copy(BuffHeader, 1, 4)='RIFF') and (Copy(BuffHeader, 9, 4)='WAVE');
  finally
    CloseFile(F);
  end;
end;

end.
